!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2004, 2006. All rights reserved.
!---------------------------------------------------------------------
!= Subroutine DynImpFunc
!
!   * Developer: SUGIYAMA Ko-ichiro
!   * Version: $Id: dynimpfunc.f90,v 1.6 2006/07/03 03:51:45 sugiyama Exp $ 
!   * Tag Name: $Name:  $
!   * Change History: 
!
!== Overview 
!
!ˡѤʡؿη׻. 
!deepconv/arare ǤϻʬȤ He-VI ˡѤƤΤ, 
!ʡؿϱˡǲ.
!
!ܥ⥸塼 HITACH SR11000 ư뤳Ȥ, 
!ʳط׻饤֥ MATRIX/MPP Ѥ. 
!
!== Error Handling
!
!== Known Bugs
!
!== Note
!
!  * Υ, 岼ȤƱľ®٤ͿƤ. 
!  *  2 ٤ΥۤѤƤ뤿, differentiate_center4 ⥸塼ꤹ뤳ȤϤǤʤΤ.
!
!== Future Plans
!

module DynImpFunc
  !
  !ˡѤϳزγƹη׻⥸塼.
  !ʡؿ򱢲ˡǲ򤯺ݤɬפȤʤ, Ǥη, 
  ! LU ʬ, LAPACK δؿΥåѡ. 
  !

  !⥸塼ɤ߹
  use dc_message, only: MessageNotify     !å
  use gridset, only: DelZ,               &! z γʻֳ
    &                DimXMin,            &! x β
    &                DimXMax,            &! x ξ
    &                DimZMin,            &! z β
    &                DimZMax,            &! z ξ
    &                RegXMin,            &! x ʪΰβ
    &                RegXMax,            &! x ʪΰξ
    &                RegZMin,            &! z ʪΰβ
    &                RegZMax              ! z ʪΰξ
  use timeset,  only: DelTimeShort        !û֥ƥå
  use damping,  only: DampSound           !Ȥθ그
  use basicset, only: CpDry,             &!ʬǮ
    &                 xz_VelSoundBasicZ, &!ܾβ® 
    &                 xz_DensBasicZ,     &!ܾ̩
    &                 xz_PotTempBasicZ,  &!ܾβ
    &                 xz_EffMolWtBasicZ   !ܾʬ̸
  use average,  only: xr_avr_xz
  use differentiate_center2, only: xr_dz_xz, xz_dz_xr, xz_dx_pz

  !ۤηػ
  implicit none

  !°λ
  private

  !ؿ public 
  public DynImpFunc_init   !롼
  public xz_Exner          !ʡؿη׻
  public xr_GradPi

  real(8)               :: beta  = 5.0d-1    !󥯥˥륽ˡʤ 0.5
                                             !ˡʤ 1
  real(8), allocatable  :: xz_F1BasicZ(:,:)  !η׻Ѥ
  real(8), allocatable  :: xr_F2BasicZ(:,:)  !η׻Ѥ
  real(8), allocatable  :: xz_VPotTempBasicZ(:,:) 
                                             !ܾβ

  integer               :: N = 10           !/μ, ˡ
  integer               :: M = 10           !ȿ
  integer               :: NUD = 1          !ξ廰ʬ
  integer               :: NLD = 1          !βʬ
  integer               :: NAL = 1          !LU ʬη L ˡ
  integer               :: NA = 5           !
  integer               :: IS = 1           !
  
  real(8), allocatable  :: A(:)             !гʬ
  real(8), allocatable  :: B(:)             !ξ廰ʬ
  real(8), allocatable  :: C(:)             !βʬ
  real(8), allocatable  :: AU1s(:)          !LU ʬη U (1 )
  real(8), allocatable  :: AU2(:,:)         !LU ʬη U (2 )
  real(8), allocatable  :: AL1(:)           !LU ʬη L (1 )
  real(8), allocatable  :: AL1s(:)          !LU ʬη L (1 )
  real(8), allocatable  :: AL2(:,:)         !LU ʬη L (2 )
  integer, allocatable  :: IP(:)            !ʬԥܥåȸ򴹤ξǼ

  !ͤ¸
  save beta, xz_F1BasicZ, xr_F2BasicZ, xz_VPotTempBasicZ
  save N, M, NUD, NLD, NAL, NA, IS
  save A, B, C, AU1s, AU2, AL1, AL1s, AL2, IP

contains

!!!--------------------------------------------------------------------!!!
  subroutine DynImpFunc_init()
    !
    !ʡؿ򱢲ˡǲ򤯺ݤɬפȤʤ, Ǥ, 
    !LU ʬԤ. 
    !

    !ۤηػ
    implicit none

    !γդ
    allocate(  &
      & A(RegZMin+1:RegZMax),   &
      & B(RegZMin+2:RegZMax),   &  
      & C(RegZMin+1:RegZMax-1), &  
      & xz_F1BasicZ(DimXMin:DimXMax, DimZMin:DimZMax), &  
      & xr_F2BasicZ(DimXMin:DimXMax, DimZMin:DimZMax), &
      & xz_VPotTempBasicZ(DimXMin:DimXMax, DimZMin:DimZMax) )

    !----------------------------------------------------------------
    ! ȶ̤Ѥͤ
    !----------------------------------------------------------------
    !̤
    xz_VPotTempBasicZ = xz_PotTempBasicZ / xz_EffMolWtBasicZ

    !η׻
    xz_F1BasicZ = ( xz_VelSoundBasicZ ** 2.0d0 ) &
      &           / (CpDry * xz_DensBasicZ *(xz_VPotTempBasicZ ** 2.0d0))
    
    xr_F2BasicZ = xr_avr_xz( &
      & CpDry * xz_DensBasicZ * (xz_VPotTempBasicZ ** 2.0d0) )
    
    A(RegZMin+2: RegZMax-1) = &
      & 1.0d0 + (beta ** 2.0d0) &
      &   * xz_F1BasicZ(RegXMax, RegZMin+2: RegZMax-1)  &  
      &   * ( xr_F2BasicZ(RegXMax, RegZMin+2: RegZMax-1)  &
      &       +  xr_F2BasicZ(RegXMax, RegZMin+1: RegZMax-2) ) &
      &   * (DelTimeShort ** 2.0d0) / ( DelZ ** 2.0d0)
    
    A(RegZMin+1) = 1.0d0 &
      & + (beta ** 2.0d0) &
      &   * xz_F1BasicZ(RegXMax, RegZMin+1)  &
      &   * xr_F2BasicZ(RegXMax, RegZMin+1) &
      &   * (DelTimeShort ** 2.0d0) / ( DelZ ** 2.0d0)

    A(RegZMax) = 1.0d0 &
      & + (beta ** 2.0d0) &
      &   * xz_F1BasicZ(RegXMax, RegZMax)  &
      &   * xr_F2BasicZ(RegXMax, RegZMax-1) &
      &   * (DelTimeShort ** 2.0d0) / ( DelZ ** 2.0d0)
    
    B(RegZMin+2: RegZMax) = &
      & - ( beta ** 2.0d0 ) &
      &   * xz_F1BasicZ(RegXMax, RegZMin+1: RegZMax-1) &
      &   * xr_F2BasicZ(RegXMax, RegZMin+1: RegZMax-1) &
      &   * (DelTimeShort ** 2.0d0) / ( DelZ ** 2.0d0 )
    
    C(RegZMin+1: RegZMax-1) = &
      & - ( beta ** 2.0d0 ) &
      &   * xz_F1BasicZ(RegXMax, RegZMin+2: RegZMax) &
      &   * xr_F2BasicZ(RegXMax, RegZMin+1: RegZMax-1) &
      &   * (DelTimeShort ** 2.0d0) / ( DelZ ** 2.0d0 )

    !----------------------------------------------------------------
    !  LU ʬ
    !----------------------------------------------------------------
    !礭ݴ
    N   = RegZMax - RegZMin !/μ, ˡ
    M   = RegXMax - RegXMin !ȿ
    NUD = 1                 !ξ廰ʬ
    NLD = 1                 !βʬ
    NAL = NLD               !LU ʬη L ˡ
!    NA  = 2 * NUD + 2 * NLD + 1
    NA  = NUD + NLD + 1

    !γ
    allocate( AL1(N), &
      &       AL2(NAL, N), AU2(NA, N),      & 
      &       AL1s(N-1), AU1s(N*(NUD+NLD+1)), IP(N) )

    !LU ʬμ¹
    !  LAPACK 
    call LinSolvLapackLU( )

    !LU ʬμ¹
    !  SSL2 
!    call LinSolvSSL2LU( )

    !LU ʬμ¹
    !  MATRIX     
!    call LinSolvMatrixLU( )
    
  end subroutine DynImpFunc_init
  

!!!--------------------------------------------------------------------!!!
  function xz_Exner(xr_FzNl, pz_VelXNs, pz_VelXAs, xr_VelZNs, xz_ExnerNs)
    !
    !ˡѤʡؿη׻. 
    !

    !ۤηػ
    implicit none
    
   !ѿ
    real(8), intent(in)      :: pz_VelXNs(DimXMin:DimXMax, DimZMin:DimZMax) 
                                                           !® u []
    real(8), intent(in)      :: pz_VelXAs(DimXMin:DimXMax, DimZMin:DimZMax)
                                                           !® u [+]
    real(8), intent(in)      :: xr_VelZNs(DimXMin:DimXMax, DimZMin:DimZMax) 
                                                           !® w []
    real(8), intent(in)      :: xr_FzNl(DimXMin:DimXMax, DimZMin:DimZMax) 
                                                           !Z γϹ[t]
    real(8), intent(in)      :: xz_ExnerNs(DimXMin:DimXMax, DimZMin:DimZMax)
                                                           !̵
    real(8)                  :: xz_Exner(DimXMin:DimXMax, DimZMin:DimZMax)
                                                           !̵[+]

    !ѿ
    real(8)               :: D(DimXMin:DimXMax, DimZMin:DimZMax)  
    real(8)               :: E(DimXMin:DimXMax, DimZMin:DimZMax)  
    real(8)               :: F(DimXMin:DimXMax, DimZMin:DimZMax)  
    real(8)               :: xz_DivVelNs(DimXMin:DimXMax, DimZMin:DimZMax)
    real(8)               :: X(RegXMin+1:RegXMax, RegZMin+1:RegZMax)

    !ѿν
    xz_Exner = 0.0d0

    
    !®٤μ«׻
    xz_DivVelNs =  xz_dx_pz( pz_VelXNs ) + xz_dz_xr( xr_VelZNs )
  
    !׻Τη
    E = xr_dz_xz( DampSound * xz_DivVelNs )                         &
      & - ( 1.0d0 - beta ) * xr_dz_xz( xz_ExnerNs )                 &
      & + xr_FzNl / xr_avr_xz( CpDry * xz_VPotTempBasicZ ) 
    
    F = - beta * xz_F1BasicZ * DelTimeShort                         &
      & * xz_dz_xr( xr_avr_xz( xz_DensBasicZ * xz_VPotTempBasicZ)   &
      &   * (                                                       &
      &       xr_VelZNs                                             &
      &       - xr_avr_xz(CpDry * xz_VPotTempBasicZ) * DelTimeShort &
      &         * ( (1.0d0 - beta) * xr_dz_xz( xz_ExnerNs )         &
      &             - xr_dz_xz( DampSound * xz_DivVelNs ) )         &
      &       + xr_FzNl * DelTimeShort                              &
      &      )                                                      &
      &   ) 
    
    D = xz_ExnerNs                                                       &
      & - (1.0d0 - beta)                                                  &
      &   * xz_F1BasicZ * DelTimeShort                                    &
      &   * xz_dz_xr(                                                     &
      &       xr_avr_xz(xz_DensBasicZ * xz_VPotTempBasicZ) * xr_VelZNs   &
      &     )                                                             &
      & - (xz_VelSoundBasicZ ** 2.0d0) * DelTimeShort                     & 
      &   / (CpDry * xz_VPotTempBasicZ)                                   &
      &   * xz_dx_pz( pz_VelXAs )                                        &
      & + F
    
    D(:, RegZMin+1) = D(:, RegZMin+1)                                  &
      & - beta * xz_F1BasicZ(:, RegZMin+1) * ( DelTimeShort ** 2.0d0 ) &
      &   * xr_F2BasicZ(:, RegZMin) * E(:,RegZMin)                     &
      &   / DelZ
    
    D(:, RegZMax) = D(:, RegZMax) &
      & + beta * xz_F1BasicZ(:, RegZMax) * ( DelTimeShort ** 2.0d0 )   &
      &   * xr_F2BasicZ(:, RegZMax) * E(:, RegZMax)                    &
      &   / DelZ     

    !-----------------------------------------------------------
    !ϢΩ켡β
    !------------------------------------------------------------
    !ν. 
    !  * D 뤿ˤ, ʬʿѱ黻ΰΡָʬפ
    !    ѤΤ, ʳɬפʬڤФ
    X = D(RegXMin + 1:RegXMax, RegZMin+1:RegZMax) 

    !η׻
    !  LAPACK 
    call LinSolvLapack( X )
    
    !η׻
    !  LAPACK 
!    call LinSolvSSL2( X )
    
    !η׻
    !  MATRIX 
!    call LinSolvMatrix( X ) 
    
    !ͤ
    xz_Exner(RegXMin+1:RegXMax, RegZMin+1:RegZMax) = X
    
  end function xz_Exner


!!!--------------------------------------------------------------------!!!
  subroutine LinSolvLapackLU(  )
    !
    ! 3  LU ʬ(). LAPACK 
    !

    !ۤηػ
    implicit none

    !ѿ
    integer                        :: INFO

    !ѿν
    INFO = 0
    
    !η׻. LAPACK . 
    call DGTTRF(N, C, A, B, AL1, IP, INFO)
    
    !Υǥå. 
!    if (INFO /= 0) then
!      call MessageNotify("Error", "lapack_linear", "INFO is not 0")
!      stop
!    end if
    
  end subroutine LinSolvLapackLU
  


!!!--------------------------------------------------------------------!!!
  subroutine LinSolvLapack( X )
    !
    !LU ʬ򤵤Ƥ 3 ϢΩ 1 (). LAPACK 
    !

    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(inout) :: X(M, N)      !/
    integer                :: NRHS
    integer                :: INFO
    integer                :: LDB
    integer                :: i
    character(1),parameter :: TRANS = 'N'

    !ѿν
    NRHS = 0
    INFO = 0
    LDB  = N
    
    !η׻. LAPACK . 
    do i = 1, M
      call DGTTRS(TRANS, N, NRHS, C, A, B, AL1, IP, X(i,:), LDB, INFO)
    end do

    !Υǥå. 
!    if (INFO /= 0) then
!      call MessageNotify("Error", "lapack_linear", "INFO is not 0")
!      stop
!    end if
     
  end subroutine LinSolvLapack



!!!--------------------------------------------------------------------!!!
  subroutine LinSolvSSL2LU(  )
    !
    ! 3  LU ʬ(). SSL2 
    !

    !ۤηػ
    implicit none

    !ѿ
    real(8), parameter  :: EPSZ = 0.0d0
    real(8)             :: VW(N)
    real(8)             :: TX(N)
    integer             :: ICON
!    integer             :: IS
    integer             :: i
    integer, parameter  :: ISW = 1


    !ѿν
    ICON = 0
    TX   = 0.0d0

    AU1s = 0.0d0
    AU1s(1) = B(2)
    AU1s(2) = A(1)
    do i = 1, N-2
      AU1s( 3 * i + 1) = B(i+2)
      AU1s( 3 * i + 2) = A(i+1)
      AU1s( 3 * i + 3) = C(i)
    end do
    AU1s( N*(NLD+NUD+1)-2) = A(N)
    AU1s( N*(NLD+NUD+1)-1) = C(N-1)
    
    !η׻. LAPACK . 
!!    call DBLU1( AU1s, N, NLD, NUD, EPSZ, IS, AL1s, IP, VW, ICON )
!    call DLTX( C, A, B, N, TX, EPSZ, ISW, IS, IP, VW, ICON )

!    !Υǥå. 
!    if (ICON /= 0) then
!      write(*,*) ICON
!      call MessageNotify("Error", "ssl2_blu1", "INFO is not 0")
!      stop
!    end if
    
  end subroutine LinSolvSSL2LU



!!!--------------------------------------------------------------------!!!
  subroutine LinSolvSSL2( X )
    !
    !LU ʬ򤵤Ƥ 3 ϢΩ 1 (). LAPACK 
    !

    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(inout) :: X(M, N)      !/
    integer                :: ICON
    integer                :: i
    integer, parameter     :: ISW = 2
    real(8), parameter     :: EPSZ = 0.0d0
    real(8)                :: VW(N)
    
    !ѿν
    ICON = 0
    
    !η׻. LAPACK . 
    do i = 1, M
!!      call DBLUX1( X(i,:), AU1s, N, NLD, NUD, AL1s, IP, ICON )
!      call DLTX( C, A, B, N, X(i,:), EPSZ, ISW, IS, IP, VW, ICON )
    end do
   
   !Υǥå. 
!    if (ICON /= 0) then
!      write(*,*) ICON
!      call MessageNotify("Error", "ssl2", "INFO is not 0")
!      stop
!    end if
    
  end subroutine LinSolvSSL2



!!!--------------------------------------------------------------------!!!
  subroutine LinSolvMATRIX(X)
    !
    ! 3  LU ʬ(). MATRIX 
    !

    !ۤηػ
    implicit none

    !ѿ
    real(8), intent(inout) :: X(M, N)    !/
    real(8)                :: TX(N, M)   !/žֹ
    real(8), parameter     :: EPS = 1.0d-16    !ðȽ
    integer                :: IOPT(2)          !楳
    real(8)                :: WK1(NLD+NUD+1,2) !
    real(8)                :: WK2(N,2)         !
    integer                :: IER

    !ѿν
    IOPT(1)     = 3
    IOPT(2)     = 1
    TX = transpose( X )

    !η׻. 
!    call HDLGBM(AU2, N, NLD, NUD, NA, TX, M, N, EPS, &
!      &         IOPT, AL2, NAL, IP, WK1, WK2, IER )

    !ν
    X = transpose( TX )

    !ƥå
!    if (IER /= 0) then 
!      write(*,*) "MATRIX code is eregular !!"
!      stop
!    end if
   
  end subroutine LinSolvMATRIX
  

!!!--------------------------------------------------------------------!!!
  subroutine LinSolvMATRIXLU( )
    !
    ! 3  LU ʬ(). MATRIX 
    !

    !ۤηػ
    implicit none

    !ѿ
    real(8)                :: TX(N, M)         !/ (ߡ)
    real(8), parameter     :: EPS = 1.0d-16    !ðȽ
    integer                :: IOPT(2)          !楳
    real(8)                :: WK1(NLD+NUD+1,2) !
    real(8)                :: WK2(N,2)         !
    integer                :: IER

    !ѿν
    AU2          = 0.0d0
    AU2(1, 2:N  ) = C
    AU2(2, 1:N  ) = A
    AU2(3, 1:N-1) = B
    IOPT(1)     = 2
    IOPT(2)     = 1
    
    !η׻. LAPACK . 
!    call HDLGBM(AU2, N, NLD, NUD, NA, TX, M, N, EPS, &
!      &         IOPT, AL2, NAL, IP, WK1, WK2, IER )

    !ƥå
!    if (IER /= 0) then 
!      write(*,*) "MATRIX code is eregular !!"
!      stop
!    end if
    
  end subroutine LinSolvMATRIXLU
  

!!!--------------------------------------------------------------------!!!
  function xr_GradPi(xz_ExnerA, xz_ExnerN, pz_VelX, xr_VelZ)
    !
    ! x ȾʻҤ줿ǤΰϷϹη׻. 
    ! 󥯡˥륽ˡѤ뤿,    +ӤǤ
    ! ʡؿͤȤƼ.
    ! ȸޤ᤿꼰Ƥ뤳Ȥ.
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8), intent(in)  :: xz_ExnerA(DimXMin:DimXMax, DimZMin:DimZMax)
                                               !ʡؿξ
    real(8), intent(in)  :: xz_ExnerN(DimXMin:DimXMax, DimZMin:DimZMax)
                                               !ʡؿξ
    real(8), intent(in)  :: pz_VelX(DimXMin:DimXMax, DimZMin:DimZMax)
                                               !ʿ®
    real(8), intent(in)  :: xr_VelZ(DimXMin:DimXMax, DimZMin:DimZMax)
                                               !ľ®
    real(8)              :: xr_GradPi(DimXMin:DimXMax, DimZMin:DimZMax)
                                               !Ϸ
    real(8)              :: xz_DivVel(DimXMin:DimXMax, DimZMin:DimZMax)
                                               !®٤μ«

    !®٤μ«
    xz_DivVel =  xz_dx_pz( pz_VelX ) + xz_dz_xr( xr_VelZ )
    
    !® w ΰϸ
    xr_GradPi = 0.0d0
    xr_GradPi =   &
      & xr_avr_xz(CpDry * xz_PotTempBasicZ / xz_EffMolWtBasicZ )   &
      &   * (                                                      &
      &       beta * xr_dz_xz( xz_ExnerA )                         &
      &       + (1.0d0 - beta) * xr_dz_xz( xz_ExnerN )             &
      &       - xr_dz_xz( DampSound * xz_DivVel )                  &
      &     )                                              
    
  end function xr_GradPi
  
  
end module DynImpFunc
