!---------------------------------------------------------------------
!     Copyright (C) GFD Dennou Club, 2005. All rights reserved.
!---------------------------------------------------------------------
!= Module MoistAdjust
!
!   * Developer: SUGIYAMA Ko-ichiro
!   * Version: $Id: moistadjust.f90,v 1.6 2006/07/11 01:38:38 sugiyama Exp $
!   * Tag Name: $Name:  $
!   * Change History: 
!
!== Overview
!
!˰Ĵˡ
! 
!== Error Handling
!
!== Bugs
!
!== Note
!
!== Future Plans
!
!

Module MoistAdjust
  !
  !˰ĴˡԤΥѥå⥸塼
  !  * ˰¾Ȥؼ, 층Ū˼¹Ԥ
  !  * ȿˤĤƤ, 줾βȿ˼¹Ԥ. 

  !⥸塼ɤ߹
  use gridset, only:  SpcNum,           &!ؼο
    &                 DimXMin,          &! x β
    &                 DimXMax,          &! x ξ
    &                 DimZMin,          &! z β
    &                 DimZMax,          &! z ξ
    &                 RegXMin,          &! x ʪΰβ
    &                 RegXMax,          &! x ʪΰξ
    &                 RegZMin,          &! z ʪΰβ
    &                 RegZMax            ! z ʪΰξ
  use basicset, only: CpDry,            &
    &                 MolWtWet,         &
    &                 SpcWetID,         &
    &                 SpcWetSymbol,     &
    &                 xz_ExnerBasicZ,   &
    &                 xz_PotTempBasicZ, &
    &                 xza_MixRtBasicZ,  &  
    &                 PressBasis,       &!̤δవ         [Pa]
    &                 CpDry,            &!ʬʿ갵Ǯ [J/K kg]
    &                 MolWtDry,         &!ʬʿʬ   [kg/mol]
    &                 GasRDry            !ʬε     [J/K kg]
  use average,  only: xz_avr_pz, xz_avr_xr, pz_avr_xz, xr_avr_xz
  use ChemData, only: ChemData_OneSpcID
  use ChemCalc, only: SvapPress, LatentHeatPerMass,  &
    &                 LatentHeatPerMol,  &
    &                 xz_SvapPress, xz_LatentHeatPerMass, &
    &                 ReactHeatNH4SHPerMass
  use MoistFunc,only: DMixRtSatDPotTemp, xz_DMixRtSatDPotTemp, &
    &                 DelMixRtNH4SH, xz_DelMixRtNH4SH

  !ۤηػ
  implicit none
  
  !°λ
  private

  !ؿ° public ѹ
  public MoistAdjust_Init        !롼
  public MoistAdjustPrm          !ѿ. ϥ롼Ѥ뤿
  public MoistAdjustSvapPress    !˰¾Ѥ˰¼Ĵ(ʰ)
  public MoistAdjustNH4SH        !ȿΰʿѤ˰¼Ĵ
  public MoistAdjustSvapPressOneByOne !˰¾Ѥ˰¼Ĵ
  public MoistAdjustNH4SHOneByOne    !ȿΰʿѤ˰¼Ĵ

  !ѿ
  real(8)      :: MinError = 1.0d-16
  integer      :: LoopNum      = 0
  integer      :: GasNum(10)   = 0
  integer      :: CloudNum(10) = 0
  integer      :: NH3Num   = 0
  integer      :: H2SNum   = 0
  integer      :: NH4SHNum = 0
  
  save MinError
  save LoopNum, CloudNum, GasNum
  save NH3Num, H2SNum, NH4SHNum
  
contains

!!!------------------------------------------------------------------!!!
  subroutine MoistAdjust_Init( )
    !
    !׻Ѥ벽ؼ ID Ф
    !  * ȶŽ(γ) ID . 
    !  * NH4SH ȿ׻뤿, NH4SH  NH3, H2S  ID.

    !ۤηػ
    implicit none

    !ѿ
    integer                  :: s
    integer                  :: n1

    !-----------------------------------------------------------
    ! γȵΤ ID Ȥ
    !-----------------------------------------------------------
    !
    LoopNum = 0

    !ؼ椫γΤ, źʬ̤ݴ.
    SelectCloud: do s = 1, SpcNum

      ! NH4SH ˤĤƤ̵
      if ( trim(SpcWetSymbol(s)) == 'NH4SH-s-Cloud' ) then 
        cycle SelectCloud
      end if

      !'Cloud' Ȥʸ󤬴ޤޤΤθĿ
      n1 = index(SpcWetSymbol(s), '-Cloud' )
      if (n1 /= 0) then
        LoopNum          = LoopNum + 1
        CloudNum(LoopNum)= s
        GasNum(LoopNum)  = minloc(SpcWetID, 1, SpcWetID == ChemData_OneSpcID(SpcWetSymbol(s)(1:n1-3) // '-g'))
      end if
    end do SelectCloud
    
    !-----------------------------------------------------------
    ! β˥, ӥ˥βǤ ID 
    !-----------------------------------------------------------
    NH3Num   = minloc(SpcWetID, 1, SpcWetID == ChemData_OneSpcID('NH3-g'))
    H2SNum   = minloc(SpcWetID, 1, SpcWetID == ChemData_OneSpcID('H2S-g'))
    NH4SHNum = minloc(SpcWetID, 1, SpcWetID == ChemData_OneSpcID('NH4SH-s'))

    !-----------------------------------------------------------
    ! ǧ
    !-----------------------------------------------------------
    if ( LoopNum == 0 ) then 
      write(*,*) "MoistAdjust: CloudNum = 0, please comment out of MoistAdjust"
!      stop
    end if

    write(*,*) "MoistAdjust_Init, LoopNum:  ", LoopNum
    write(*,*) "MoistAdjust_Init, CloudNum: ", CloudNum
    write(*,*) "MoistAdjust_Init, GasNum:   ", GasNum    
    write(*,*) "MoistAdjust_Init, NH3Num:   ", NH3Num
    write(*,*) "MoistAdjust_Init, H2SNum:   ", H2SNum
    write(*,*) "MoistAdjust_Init, NH4SHNum: ", NH4SHNum

  end subroutine MoistAdjust_Init


  subroutine MoistAdjustPrm( M1, M2, M3, M4, M5, M6 )
    
    implicit none
    integer, intent(out) ::  M1, M2(10), M3(10), M4, M5, M6

    M1 = LoopNum
    M2 = CloudNum
    M3 = GasNum    
    M4 = NH3Num
    M5 = H2SNum
    M6 = NH4SHNum

    write(*,*) M1, M2, M3, M4, M5, M6 
  end subroutine MoistAdjustPrm




!!!------------------------------------------------------------------!!!
  subroutine MoistAdjustSvapPressOneByOne(xz_Exner, xz_PotTemp, xza_MixRt)
    !
    ! ˰¾Ѥ˰Ĵˡμ¹
    ! ץǤ, ʻ 1  1 ĤФ, ̤«ޤ
    ! ȿɤ򷫤֤
    !

    !ۤηػ
    implicit none
    
    !ѿ
    real(8),intent(in)   :: xz_Exner(DimXMin:DimXMax, DimZMin:DimZMax) 
                                                          !ʡؿ
    real(8),intent(inout):: xz_PotTemp(DimXMin:DimXMax, DimZMin:DimZMax) 
                                                          !
    real(8),intent(inout):: xza_MixRt(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                                          !
    real(8) :: MixRtV_pre
    real(8) :: MixRtV_nxt
    real(8) :: MixRtC_pre
    real(8) :: MixRtC_nxt
    real(8) :: PotTemp_pre
    real(8) :: PotTemp_nxt    
    real(8) :: ExnerAll
    real(8) :: TempAll
    real(8) :: DelMixRt
    real(8) :: MixRtSat
    real(8) :: Gamma

    integer :: i, k, s, num(DimXMin:DimXMax, DimZMin:DimZMax)          ! ź  
    
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    MixRtV_pre  = 0.0d0
    MixRtV_nxt  = 0.0d0
    MixRtC_pre  = 0.0d0
    MixRtC_nxt  = 0.0d0
    PotTemp_pre = 0.0d0
    PotTemp_nxt = 0.0d0
    
    ExnerAll    = 0.0d0
    TempAll     = 0.0d0
    DelMixRt    = 0.0d0
    MixRtSat    = 0.0d0 
    Gamma       = 0.0d0
    
    num   = 0
    
    !롼פ󤹤Τ, ˤĤƤ.  
    LoopSvapPress: do s = 1, LoopNum
!      write(*,*) 'pre: ', minval(xza_MixRt(:,:,GasNum(s))), maxval(xza_MixRt(:,:,GasNum(s)))
!      write(*,*) 'pre: ', minval(xza_MixRt(:,:,CloudNum(s))), maxval(xza_MixRt(:,:,CloudNum(s)))
            
      do k = RegZMin, RegZMax
        do i = RegXMin, RegXMax
          
          !˰ˡǤϰϤѲʤ. 
          ExnerAll = xz_Exner(i,k) + xz_ExnerBasicZ(i,k)
          
          !ޤǤ줿ʬ̤ͤȤߤʤ. źɲ
          MixRtV_pre  = xza_MixRt(i,k,GasNum(s))   + xza_MixRtBasicZ(i,k,GasNum(s))
          MixRtC_pre  = xza_MixRt(i,k,CloudNum(s)) + xza_MixRtBasicZ(i,k,CloudNum(s))
          PotTemp_pre = xz_PotTemp(i,k)
          
          !롼ײν
          num(i,k) = 0
          
          Adjusting: do 
            !---------------------------------------------------------------
            ! ˰¾˰º
            !---------------------------------------------------------------
            !
            TempAll = (PotTemp_pre + xz_PotTempBasicZ(i,k)) * ExnerAll
            
            !˰¾˰º׻(ܾ줫κ). 
            MixRtSat =                                                    &
              & SvapPress(SpcWetID(CloudNum(s)), TempAll)                 &
              &  * MolWtWet(CloudNum(s))                                  &
              &  / (MolWtDry * PressBasis * (ExnerAll ** (CpDry / GasRDry)) )
            
            !ʲ줿Ǯ
            Gamma = LatentHeatPerMass(SpcWetID(CloudNum(s)), TempAll) &
              &     / (ExnerAll * CpDry)
            
            !---------------------------------------------------------------
            ! γؤѴԤ
            ! ʬ˰¾¿ or γ椬
            !---------------------------------------------------------------
            !ŷ̤
            DelMixRt = max( MixRtV_pre - MixRtSat, - MixRtC_pre )                           &
              & / (1.0d0 + Gamma * DMixRtSatDPotTemp(SpcWetID(CloudNum(s)), MolWtWet(CloudNum(s)), TempAll, ExnerAll) )
                            
            PotTemp_nxt = PotTemp_pre + Gamma * DelMixRt
            MixRtV_nxt  = MixRtV_pre - DelMixRt
            MixRtC_nxt  = MixRtC_pre + DelMixRt              

            !̤«Ƥ鷫֤ߤ
            if (abs((PotTemp_nxt - PotTemp_pre) / PotTemp_nxt) <= MinError ) then 
              xz_PotTemp(i,k)            = PotTemp_nxt                 
              xza_MixRt(i,k,GasNum(s))   = MixRtV_nxt - xza_MixRtBasicZ(i,k,GasNum(s))
              xza_MixRt(i,k,CloudNum(s)) = MixRtC_nxt - xza_MixRtBasicZ(i,k,CloudNum(s))
              exit Adjusting
            end if
            
            !롼ײꤹ饨顼Ǥ³
            if ( num(i,k) > 20 ) then 
              write(*,*) i, k, "Looping is too much, num > 20"
              xz_PotTemp(i,k)          = PotTemp_nxt     
              xza_MixRt(i,k,GasNum(s))   = MixRtV_nxt - xza_MixRtBasicZ(i,k,GasNum(s))
              xza_MixRt(i,k,CloudNum(s)) = MixRtC_nxt - xza_MixRtBasicZ(i,k,CloudNum(s))
              exit Adjusting
            end if
            
            !---------------------------------------------------------------
            ! ֤Τѿ
            !---------------------------------------------------------------
            PotTemp_pre = PotTemp_nxt
            MixRtV_pre  = MixRtV_nxt
            MixRtC_pre  = MixRtC_nxt
            num(i,k)    = num(i,k) + 1
            
          end do Adjusting
          
        end do
      end do
      
    end do LoopSvapPress

    
  end subroutine MoistAdjustSvapPressOneByOne

  
!!!------------------------------------------------------------------!!!
  subroutine MoistAdjustSvapPress(xz_Exner, xz_PotTemp, xza_MixRt)
    !
    ! ˰¾Ѥ˰Ĵˡμ¹
    ! ץǤ, ͽ᤿ȿɤԤ. 
    !

    !ۤηػ
    implicit none
    
    !ѿ
    real(8),intent(in)   :: xz_Exner(DimXMin:DimXMax, DimZMin:DimZMax) 
                                                          !ʡؿ
    real(8),intent(inout):: xz_PotTemp(DimXMin:DimXMax, DimZMin:DimZMax) 
                                                          !
    real(8),intent(inout):: xza_MixRt(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                                          !
    integer, parameter   :: ItrNum = 4                    !ȿɤβ

    real(8) :: xz_MixRtV_pre(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_MixRtV_nxt(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_MixRtC_pre(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_MixRtC_nxt(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_PotTemp_pre(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_PotTemp_nxt(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_ExnerAll(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_TempAll(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_DelMixRt(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_MixRtSat(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_Gamma(DimXMin:DimXMax, DimZMin:DimZMax) 
    integer :: i, s                                       ! ź  
 
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    xz_MixRtV_pre  = 0.0d0
    xz_MixRtV_nxt  = 0.0d0
    xz_MixRtC_pre  = 0.0d0
    xz_MixRtC_nxt  = 0.0d0
    xz_PotTemp_pre = 0.0d0
    xz_PotTemp_nxt = 0.0d0
    
    xz_ExnerAll    = 0.0d0
    xz_TempAll     = 0.0d0
    xz_DelMixRt    = 0.0d0
    xz_MixRtSat    = 0.0d0 
    xz_Gamma       = 0.0d0
    
    !---------------------------------------------------------------------
    ! ˰Ĵˡμ¹
    !   롼פ󤹤Τ, ˤĤƤ.  
    !---------------------------------------------------------------------
    LoopSvapPress: do s = 1, LoopNum
      
      !˰ˡǤϰϤѲʤ. 
      xz_ExnerAll = xz_Exner + xz_ExnerBasicZ
          
      !ޤǤ줿ʬ̤ͤȤߤʤ. źɲ
      xz_MixRtV_pre  = xza_MixRt(:,:,GasNum(s))   + xza_MixRtBasicZ(:,:,GasNum(s))
      xz_MixRtC_pre  = xza_MixRt(:,:,CloudNum(s)) + xza_MixRtBasicZ(:,:,CloudNum(s))
      xz_PotTemp_pre = xz_PotTemp
          
      Adjusting: do i = 1, ItrNum
        !---------------------------------------------------------------
        ! ˰¾˰º
        !---------------------------------------------------------------
        !
        xz_TempAll = ( xz_PotTemp_pre + xz_PotTempBasicZ ) * xz_ExnerAll

        !˰¾˰º׻(ܾ줫κ). 
        xz_MixRtSat =                                                    &
          & xz_SvapPress(SpcWetID(CloudNum(s)), xz_TempAll)              &
          &  * MolWtWet(CloudNum(s))                                     &
          &  / (MolWtDry * PressBasis * (xz_ExnerAll ** (CpDry / GasRDry)) )
        
        !ʲ줿Ǯ
        xz_Gamma = xz_LatentHeatPerMass(SpcWetID(CloudNum(s)), xz_TempAll) &
          &        / (xz_ExnerAll * CpDry)
        
        !ŷ̤. 
        !  ŷ뤬ˤ, xz_MixRtV_pre - xz_MixRtSat ɬͤȤʤ.
        !  ȯˤ, ȯ̤ - MixRtC Ķ뤳ȤϤʤ. 
        xz_DelMixRt = &
          max( xz_MixRtV_pre - xz_MixRtSat, - xz_MixRtC_pre ) &
          &   / (1.0d0 + xz_Gamma * xz_DMixRtSatDPotTemp( &
          &           SpcWetID(CloudNum(s)), MolWtWet(CloudNum(s)), xz_TempAll, xz_ExnerAll & 
          &        ) )
               
        !꿿˶ᤤͤ׻
        xz_PotTemp_nxt = xz_PotTemp_pre + xz_Gamma * xz_DelMixRt
        xz_MixRtV_nxt  = xz_MixRtV_pre  - xz_DelMixRt
        xz_MixRtC_nxt  = xz_MixRtC_pre  + xz_DelMixRt
        
        !֤Τѿ
        xz_PotTemp_pre = xz_PotTemp_nxt
        xz_MixRtV_pre  = xz_MixRtV_nxt
        xz_MixRtC_pre  = xz_MixRtC_nxt

      end do Adjusting
      
      xz_PotTemp                 = xz_PotTemp_nxt                 
      xza_MixRt(:,:,GasNum(s))   = xz_MixRtV_nxt - xza_MixRtBasicZ(:,:,GasNum(s))
      xza_MixRt(:,:,CloudNum(s)) = xz_MixRtC_nxt - xza_MixRtBasicZ(:,:,CloudNum(s))
      
    end do LoopSvapPress
    
  end subroutine MoistAdjustSvapPress

  
!!!--------------------------------------------------------------------------!!!
  subroutine MoistAdjustNH4SHOneByOne(xz_Exner, xz_PotTemp, xza_MixRt ) 
    !
    ! ȿΰʿ Kp Ѥ˰¼Ĵˡ
    ! , ߤ NH3 + H2S --> NH4SH ȿˤΤб
    !
    ! ץǤ, ʻ 1  1 ĤФ, ̤«ޤ
    ! ȿɤ򷫤֤
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8),intent(in)   :: xz_Exner(DimXMin:DimXMax, DimZMin:DimZMax) 
                                                          !ʡؿ
    real(8),intent(inout):: xz_PotTemp(DimXMin:DimXMax, DimZMin:DimZMax) 
                                                          !
    real(8),intent(inout):: xza_MixRt(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                                          !Žʬκ
    real(8) :: PotTemp_pre
    real(8) :: PotTemp_nxt
    real(8) :: MixRtNH3_pre
    real(8) :: MixRtNH3_nxt
    real(8) :: MixRtH2S_pre
    real(8) :: MixRtH2S_nxt
    real(8) :: MixRtNH4SH_pre
    real(8) :: MixRtNH4SH_nxt
    
    real(8) :: ExnerAll
    real(8) :: PressAll
    real(8) :: TempAll
    real(8) :: Gamma
    real(8) :: DelMixRt
    
    integer :: i, k, num(DimXMin:DimXMax, DimZMin:DimZMax)        ! ź  
!    integer :: l(2)
            
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    PotTemp_pre = 0.0d0
    PotTemp_nxt = 0.0d0
    MixRtNH3_pre   = 0.0d0
    MixRtNH3_nxt   = 0.0d0
    MixRtH2S_pre   = 0.0d0
    MixRtH2S_nxt   = 0.0d0
    MixRtNH4SH_pre = 0.0d0
    MixRtNH4SH_nxt = 0.0d0
    
    ExnerAll  = 0.0d0
    PressAll  = 0.0d0
    TempAll   = 0.0d0
    Gamma     = 0.0d0
    DelMixRt  = 0.0d0
    num       = 0
  
    do k = RegZMin, RegZMax
      do i = RegXMin, RegXMax

        !˰ˡǤϰϤѲʤ. 
        ExnerAll = xz_Exner(i,k) + xz_ExnerBasicZ(i,k)
        PressAll = PressBasis * (ExnerAll ** (CpDry / GasRDry))        

        !ޤǤ줿ʬ̤ͤȤߤʤ. źɲ
        MixRtNH3_pre    = xza_MixRt(i,k,NH3Num)   + xza_MixRtBasicZ(i,k,NH3Num)
        MixRtH2S_pre    = xza_MixRt(i,k,H2SNum)   + xza_MixRtBasicZ(i,k,H2SNum)
        MixRtNH4SH_pre  = xza_MixRt(i,k,NH4SHNum) + xza_MixRtBasicZ(i,k,NH4SHNum)
        PotTemp_pre     = xz_PotTemp(i,k)
        
        !롼ײν
        num(i,k) = 0
        
        AdjustNH4SH: do
          !---------------------------------------------------------------
          ! ѿν
          !---------------------------------------------------------------
          !
          TempAll = (PotTemp_pre + xz_PotTempBasicZ(i,k)) * ExnerAll
          
          !ʲ줿ȿǮ (NH4SH kg ФǮ)
          Gamma = ReactHeatNH4SHPerMass / (ExnerAll * CpDry)
          
          !˰٤׻
          ! NH4SH ʾ˾ȯʤޤʤ褦ˤ. 
          DelMixRt = &
            & max (                                                   &
            &     DelMixRtNH4SH(                                      &
            &          TempAll, PressAll, MixRtNH3_pre, MixRtH2S_pre, &
            &          MolWtWet(NH3Num), MolWtWet(H2SNum)             &
            &       ),                                                &
            &   - MixRtNH4SH_pre                                      &
            &  ) 

          !---------------------------------------------------------------
          ! 꿿˶ᤤͤ˰¾˰º
          !---------------------------------------------------------------
          ! NH4SH κ
          !
          MixRtNH4SH_nxt = MixRtNH4SH_pre + DelMixRt
          
          ! DelPress 򸵤, NH3  H2S κ
          MixRtNH3_nxt = MixRtNH3_pre - DelMixRt * MolWtWet(NH3Num) / MolWtWet(NH4SHNum)
          MixRtH2S_nxt = MixRtH2S_pre - DelMixRt * MolWtWet(H2SNum) / MolWtWet(NH4SHNum)
          
          !̤
          PotTemp_nxt = PotTemp_pre + Gamma * DelMixRt
          
!          if (k > 22 .AND. k < 24 .AND. i == 24) then 
!            write(*,*) 'CHECK'
!            write(*,*) num, i, k, DelMixRt
!            write(*,*) num, i, k, Gamma, Gamma * DelMixRt
!           
!            write(*,*) num, i, k, xza_MixRt(i,k,H2SNum), xza_MixRtBasicZ(i,k,H2SNum)
!            write(*,*) num, i, k, PotTemp_pre,    " --> ", PotTemp_nxt
!            write(*,*) num, i, k, MixRtNH3_pre,   " --> ", MixRtNH3_nxt
!            write(*,*) num, i, k, MixRtH2S_pre,   " --> ", MixRtH2S_nxt
!            write(*,*) num, i, k, MixRtNH4SH_pre, " --> ", MixRtNH4SH_nxt
!            write(*,*) 'pre', MixRtNH3_pre + MixRtH2S_pre + MixRtNH4SH_pre 
!            write(*,*) 'nxt', MixRtNH3_nxt + MixRtH2S_nxt + MixRtNH4SH_nxt 
!          end if
          
          !---------------------------------------------------------------
          ! «Ƚ
          !---------------------------------------------------------------
          !̤«Ƥ鷫֤ߤ
          if (abs((PotTemp_nxt - PotTemp_pre) / PotTemp_nxt) <= MinERROR   &
            & .OR. abs(PotTemp_nxt - PotTemp_pre) <= MinERROR             ) then 
            xz_PotTemp(i,k)         = PotTemp_nxt                 
            xza_MixRt(i,k,NH3Num)   = MixRtNH3_nxt - xza_MixRtBasicZ(i,k,NH3Num)
            xza_MixRt(i,k,H2SNum)   = MixRtH2S_nxt - xza_MixRtBasicZ(i,k,H2SNum)
            xza_MixRt(i,k,NH4SHNum) = MixRtNH4SH_nxt - xza_MixRtBasicZ(i,k,NH4SHNum)
            exit AdjustNH4SH
          end if
          
          !롼ײꤹ饨顼Ǥ³
          if ( num(i,k) > 30 ) then 
            write(*,*) "Looping is too much, num > 30"
            write(*,*) "xz_PotTemp(i,k) ", i, k, PotTemp_nxt, PotTemp_pre
            xz_PotTemp(i,k)         = PotTemp_nxt                 
            xza_MixRt(i,k,NH3Num)   = MixRtNH3_nxt - xza_MixRtBasicZ(i,k,NH3Num)
            xza_MixRt(i,k,H2SNum)   = MixRtH2S_nxt - xza_MixRtBasicZ(i,k,H2SNum)
            xza_MixRt(i,k,NH4SHNum) = MixRtNH4SH_nxt - xza_MixRtBasicZ(i,k,NH4SHNum)
            exit AdjustNH4SH
          end if
          
          !֤Τѿ
          PotTemp_pre    = PotTemp_nxt
          MixRtNH3_pre   = MixRtNH3_nxt 
          MixRtH2S_pre   = MixRtH2S_nxt 
          MixRtNH4SH_pre = MixRtNH4SH_nxt 
          num(i,k)       = num(i,k) + 1
          
        end do AdjustNH4SH
      end do
    end do
    
!    l = maxloc( num )
!    write(*,*) l(1), num( l(1), : )

  end subroutine MoistAdjustNH4SHOneByOne


!!!--------------------------------------------------------------------------!!!
  subroutine MoistAdjustNH4SH(xz_Exner, xz_PotTemp, xza_MixRt ) 
    !
    ! NH3 + H2S --> NH4SH ȿΰʿ Kp Ѥ˰¼Ĵˡ
    !
    
    !ۤηػ
    implicit none
    
    !ѿ
    real(8),intent(in)   :: xz_Exner(DimXMin:DimXMax, DimZMin:DimZMax) 
                                                          !ʡؿ
    real(8),intent(inout):: xz_PotTemp(DimXMin:DimXMax, DimZMin:DimZMax) 
                                                          !
    real(8),intent(inout):: xza_MixRt(DimXMin:DimXMax, DimZMin:DimZMax, SpcNum)
                                                          !Žʬκ
    real(8) :: xz_PotTemp_pre(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_PotTemp_nxt(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_MixRtNH3_pre(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_MixRtNH3_nxt(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_MixRtH2S_pre(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_MixRtH2S_nxt(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_MixRtNH4SH_pre(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_MixRtNH4SH_nxt(DimXMin:DimXMax, DimZMin:DimZMax) 
    
    real(8) :: xz_ExnerAll(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_PressAll(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_TempAll(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_Gamma(DimXMin:DimXMax, DimZMin:DimZMax) 
    real(8) :: xz_DelMixRt(DimXMin:DimXMax, DimZMin:DimZMax) 
    
    integer            :: i
    integer, parameter :: ItrNum = 2
            
    !---------------------------------------------------------------------
    ! 
    !---------------------------------------------------------------------
    xz_PotTemp_nxt = 0.0d0
    xz_MixRtNH3_nxt   = 0.0d0
    xz_MixRtH2S_nxt   = 0.0d0
    xz_MixRtNH4SH_nxt = 0.0d0
    
    xz_Gamma     = 0.0d0
    xz_DelMixRt  = 0.0d0

    !˰ˡǤϰϤѲʤ. 
    xz_ExnerAll = xz_Exner + xz_ExnerBasicZ
    xz_PressAll = PressBasis * (xz_ExnerAll ** (CpDry / GasRDry))
        
    !ޤǤ줿ʬ̤ͤȤߤʤ. źɲ
    xz_MixRtNH3_pre(:,:)    = xza_MixRt(:,:,NH3Num)   + xza_MixRtBasicZ(:,:,NH3Num)
    xz_MixRtH2S_pre(:,:)    = xza_MixRt(:,:,H2SNum)   + xza_MixRtBasicZ(:,:,H2SNum)
    xz_MixRtNH4SH_pre(:,:)  = xza_MixRt(:,:,NH4SHNum) + xza_MixRtBasicZ(:,:,NH4SHNum)
    xz_PotTemp_pre          = xz_PotTemp
    
    AdjustNH4SH: do i = 1, ItrNum
      !---------------------------------------------------------------
      ! ѿν
      !---------------------------------------------------------------
      !
      xz_TempAll = ( xz_PotTemp_pre + xz_PotTempBasicZ ) * xz_ExnerAll
      
      !ʲ줿ȿǮ (NH4SH kg ФǮ)
      xz_Gamma = ReactHeatNH4SHPerMass / ( xz_ExnerAll * CpDry )

      !NH4SH 
      xz_DelMixRt =                                                             &
        & max(                                                                  &
        &      xz_DelMixRtNH4SH(                                                &
        &            xz_TempAll, xz_PressAll, xz_MixRtNH3_pre, xz_MixRtH2S_pre, &
        &            MolWtWet(NH3Num), MolWtWet(H2SNum)                         &
        &          ),                                                           &
        &    - xz_MixRtNH4SH_pre                                                &
        &  )

      !---------------------------------------------------------------
      ! 꿿˶ᤤͤ˰¾˰º
      !---------------------------------------------------------------
      ! NH4SH κ
      xz_MixRtNH4SH_nxt  = xz_MixRtNH4SH_pre + xz_DelMixRt
      
      ! DelPress 򸵤, NH3  H2S κ
      xz_MixRtNH3_nxt = xz_MixRtNH3_pre - xz_DelMixRt * MolWtWet(NH3Num) / MolWtWet(NH4SHNum)
      xz_MixRtH2S_nxt = xz_MixRtH2S_pre - xz_DelMixRt * MolWtWet(H2SNum) / MolWtWet(NH4SHNum)
          
      !̤
      xz_PotTemp_nxt = xz_PotTemp_pre + xz_Gamma * xz_DelMixRt
      
      !롼פ󤹤ѿѲ
      xz_PotTemp_pre     = xz_PotTemp_nxt
      xz_MixRtNH3_pre   = xz_MixRtNH3_nxt 
      xz_MixRtH2S_pre   = xz_MixRtH2S_nxt 
      xz_MixRtNH4SH_pre = xz_MixRtNH4SH_nxt 

    end do AdjustNH4SH

    xz_PotTemp              = xz_PotTemp_nxt                 
    xza_MixRt(:,:,NH3Num)   = xz_MixRtNH3_nxt   - xza_MixRtBasicZ(:,:,NH3Num)
    xza_MixRt(:,:,H2SNum)   = xz_MixRtH2S_nxt   - xza_MixRtBasicZ(:,:,H2SNum)
    xza_MixRt(:,:,NH4SHNum) = xz_MixRtNH4SH_nxt - xza_MixRtBasicZ(:,:,NH4SHNum)
    
  end subroutine MoistAdjustNH4SH
  
end Module MoistAdjust
